9.1   os32: environ(7)

NOME

    environ - ambiente del processo elaborativo

SINTASSI

    extern char **environ;

DESCRIZIONE

    La variabile <environ>, dichiarata nel file unistd.h, punta a un array di
    stringhe, ognuna delle quali rappresenta una variabile di ambiente, con il
    valore a lei assegnato. Pertanto, il contenuto di queste stringhe ha una
    forma del tipo <nome>=<valore>. Per esempio HOME=/home/user.

    In generale, l'accesso diretto ai contenuti di questo array non e`
    conveniente, in quanto sono disponibili delle funzioni che facilitano la
    gestione di questi dati in forma di variabili di ambiente.

    Dal momento che le funzioni di accesso alle informazioni sulle variabili di
    ambiente sono definite nel file stdlib.h, la gestione effettiva dell'array
    di stringhe a cui punta <environ> e` inserita nei file contenuti nella
    directory lib/stdlib/ di os32. Per la precisione, nel file lib/stdlib/
    environment.c si dichiara l'array di caratteri <_environment_table[][]> e 
    array di puntatori a caratteri <_environment[]>:

    char  _environment_table[ARG_MAX/32][ARG_MAX/16];
    char *_environment[ARG_MAX/32+1];

    L'array <_environment_table[][]> viene inizializzato con lo stato delle
    variabili di ambiente ereditate con l'avvio del processo; inoltre, all'
    array <_environment[]> vengono assegnati i puntatori alle varie stringhe
    che si possono estrapolare da <_environment_table[]>. Questo lavoro
    iniziale avviene per opera della funzione <_environment_setup()>, la quale
    viene avviata a sua volta dal file crt0.s. Successivamente, nello stesso
    file crt0.s, viene copiato l'indirizzo dell'<_environment[]> nella
    variabile <environ>, di cui sopra.

FILE SORGENTI

    lib/unistd.h [13.30]

    lib/stdlib.h [13.19]

    lib/unistd/environ.c [13.30.9]

    applic/crt0.mer.s [14.1.12]

    applic/crt0.sep.s [14.1.13]

    lib/stdlib/environment.c [13.19.8]

    lib/stdlib/getenv.c [13.19.10]

    lib/stdlib/putenv.c [13.19.15]

    lib/stdlib/setenv.c [13.19.18]

    lib/stdlib/unsetenv.c [13.19.21]

VEDERE ANCHE

    getenv(3) [6.52], putenv(3) [6.94], setenv(3) [6.104], unsetenv(3) [6.104].

